#ifndef CCAPTEURHUM_SI7021_A20_H
#define CCAPTEURHUM_SI7021_A20_H

#include <QObject>
#include <QThread>
#include "global.h"
#include "ci2c.h"
#include "csharedmemory"

class CCapteurHum_SI7021_A20 : public QThread
{
  Q_OBJECT

public:
  explicit CCapteurHum_SI7021_A20(QObject *mParent);
  ~CCapteurHum_SI7021_A20();
  void run();
  float lireMesure();

private:
  int mNum;
  CMemoirePartage *mShm;
  CI2c *mi2c;
  unsigned char *mAddr;
  bool mArret;
  bool mStopped;

signals:

public slots:
  void stop();

};

#endif // CCAPTEURHUM_SI7021_A20_H
