#include "global.h"
#include "csharedmemory.h"

CSharedMemory::CSharedMemory(QObject *parent)
{
  m_parent = parent;
  setKey(KEY);
  m_taille = size;
  m_adrBase = NULL;
  qDebug() << "Objet CMemoirePartage créé par " << m_parent->thread();
}

CSharedMemory::~CSharedMemory()
{
  detach();
  qDebug() << "Objet CMemoirePartage détruit par " << m_parent->thread();
}

int CSharedMemory::memoireAttacherouCreer()
{
  int res;

  attach();
  if(!isAttached()){
    res = create(5*sizeof(T_Mes));
    if (!res) {
                  QString mess="CSharedMemory::attacherOuCreer Erreur de création de la mémoire partagée.";
                  emit sigErreur(mess);
                  return ERREUR;
             } // if res
        } // if isattached
  attach();
  m_adrBase = (float *)data();
  return 0;
}

int CSharedMemory::memoireAttacher()
{
   attach();
   if (!isAttached()) {   // si existe pas
          QString mess="CSharedMemory::attacherSeulement Erreur de création de la mémoire partagée.";
        emit sigErreur(mess);
        return ERREUR;
      } // if isattached
      m_adrBase = (float *)data();
      return 0;
}

float CSharedMemory::shmLire()
{
  if ( (no<0) && (no>2) ) {
      QString mess="CSharedMemory::lire ERREUR, indice de la mesure incorrecte.";
      emit sigErreur(mess);
      return ERREUR;
  } // if no
  if (!isAttached()) {   // si existe pas alors création
      QString mess="CSharedMemory::lire Erreur mémoire partagée non attachée. ";
    emit sigErreur(mess);
    return ERREUR;
  } // if isattached
  return m_adrBase[no];
}

float CSharedMemory::shmEcrire()
{
  if ( (no<0) && (no>2) ) {
          QString mess="CSharedMemory::ecrire ERREUR, indice de la mesure incorrecte.";
          emit sigErreur(mess);
          return ERREUR;
      } // if no
      if (!isAttached()) {   // si existe pas
          QString mess="CSharedMemory::ecrire Erreur mémoire partagée non attachée.";
          emit sigErreur(mess);
          return ERREUR;
      } // if isattached
      m_adrBase[no] = mesure;
      return 0;
}
