#include <iostream>
#include "VL53L0X.hpp"
#include <unistd.h>
//g++ VL53L0X.cpp I2Cdev.cpp singleMinimal_V5.cpp -o singleMinimal_V5
int main() {
	VL53L0X sensor;
	sensor.init();
	sensor.setTimeout(200);

	while(1) {
		uint16_t distance = sensor.readRangeSingleMillimeters();
		if (sensor.timeoutOccurred()) {
			std::cout << "timeout!" << std::endl;
		} else {
			usleep(500000);  // 0,5 sec
		if (distance < 1000)	{
			std::cout << (distance * 0.1) << " cm"<< std::endl; //Distance en cm
		} else {
			std::cout << (distance * 0.001) << " m"<< std::endl; //Distance en m
			}
		}
	}

	return 0;
}
