#ifndef APPEDD_H
#define APPEDD_H

#include <ui_appedd.h>
#include <QMainWindow>

#include "ccapteurdist_vl53l0x.h"
#include "ccapteurgps.h"
#include "ccapteurtemhum_si7021_a20.h"
#include "cdevicespimax7456.h"
#include "csharedmemory.h"

namespace Ui {
  class AppEdd;
}

class AppEdd : public QMainWindow
{
  Q_OBJECT

public:
  explicit AppEdd(QWidget *parent = 0);
  ~AppEdd();


private slots:
  void on_Humidite_stateChanged(int arg1);
  void on_Quitter_clicked();
  void on_Temperature_stateChanged(int arg1);
  void on_Distance_stateChanged(int arg1);
  void on_GPS_stateChanged(int arg1);
  void on_Reset_clicked();
  void on_ALL_clicked();
  void on_SHM_clicked();

private:
  Ui::AppEdd *ui;
  CDeviceSpiMax7456 *m_max;
};

#endif // APPEDD_H
