#ifndef CSHAREDMEMORY_H
#define CSHAREDMEMORY_H

#include <QSharedMemory>
#include <QDebug>
#include "global.h"

typedef struct{
  float temSI7021_A20;
  float humSI7021_A20;
  float distVL53L0X;
  float gps;
}T_SHM_DATA;

class CSharedMemory : public QSharedMemory
{
      Q_OBJECT
public:
  explicit CSharedMemory(QObject *parent);
  ~CSharedMemory();
  int memoireAttacherouCreer();
  int memoireAttacher();
  float shmEcrire();
  float shmLire();

private:
  int m_taille;
  float *m_adrBase;
  QObject *m_parent;

signals :
  void sigErreur(QString mess);
};

#endif // CMEMOIREPARTAGE_H
