// Récupération des données d'un module GPS par Rpi
#include <iostream>
#include <string.h>
#include <errno.h>
#include <wiringPi.h>
#include <wiringSerial.h>

using namespace std;

// g++ -o GPS3 -lwiringPi GPS3.cpp  

int main ()
{
while(1) {
  int fd ;

  if (wiringPiSetup () == -1)
  {
	cout<<"Impossible de démarrer wirinPi. Erreur : "<<strerror (errno);
	return 1 ;
  }
  
  if ((fd = serialOpen ("/dev/ttyAMA0", 9600)) < 0)
  {
 	cout<<"Impossible d'ouvrir le port /dev/ttyAMA0. Erreur : "<<strerror (errno);
	return 1 ;
  }


char data;

for (int i(0); i<400; i++)
	{
	data = serialGetchar(fd);		// Lecture et stockage dans data 
	cout<<data<<" ";                           
	}
cout<<endl;

serialFlush(fd);		// Effacement buffers série avant lecture Rx

serialClose(fd); 		// Fermeture de l'interface série 
}
return 0 ;

}
